#ifndef __windows_inc__
#include "windows.inc"
#endif

// example of detecting memory (also variables) change.
// compile for console


// extended structure used in structured exceptions handling (SEH)
// usage in CMemoryProtector::Protect and CMemoryProtector::Unprotect
struct MySEH // linked list in [fs:0]
{
	// required
	LPVOID  next;
	FARPROC handler;       // _except_handler function declared in excpt.inc
	// user defined
	LPVOID  owner;         // CMemoryProtector*
	LPVOID  ChangePtr;     // accessed guard memory
	DWORD   PreviousValue; // saved value from ChangePtr
}

//---------------------------------------------------------------------
// the base class
class CMemoryProtector
{
	declare  CMemoryProtector();
	declare _CMemoryProtector();

	// allocate R/W memory that can be protected
	declare  Alloc(int size),void*;
	declare  GetPointer(),void*;
	// protect allocated memory - any write attempt will be signalled
	declare  Protect(),BOOL;
	// unprotect allocated memory
	declare  Unprotect(),BOOL;

	// called when memory write has been detected.
	// Here you can deny the write by writing the previous value
	declare virtual OnMemoryChange(void* address,DWORD PreviousValue);

	void *m_ProtectedMemory;
	int   m_size;
	DWORD m_OldProtect;

	MySEH seh;
}


#ifdef __cprotector_src__
declare GetFS(int index),DWORD;
declare SetFS(int index,DWORD value);
#else
declare extern GetFS(int index),DWORD;
declare extern SetFS(int index,DWORD value);
#endif
